require 'csv'

$all_magic = [
    {name: "Stone Hammer", element: "Earth", required: [1,0,0,0,0,0,0]},
    {name: "Earth Lance", element: "Earth", required: [5,0,0,0,0,0,0]},
    {name: "Petrify Breath", element: "Earth", required: [3,0,0,0,0,0,0]},
    {name: "Stone Impact", element: "Earth", required: [3,0,0,0,0,2,0]},
    {name: "Titanic Roar", element: "Earth", required: [8,0,0,0,0,4,0]},
    {name: "Aqua Bleed", element: "Water", required: [0,1,0,0,0,0,0]},
    {name: "Blue Impact", element: "Water", required: [0,5,0,0,0,0,0]},
    {name: "Diamond Dust", element: "Water", required: [0,4,0,2,0,1,0]},
    {name: "Fire Bolt", element: "Fire", required: [0,0,1,0,0,0,0]},
    {name: "Flare Arrow", element: "Fire", required: [0,0,3,0,0,0,0]},
    {name: "Napalm Breath", element: "Fire", required: [0,0,6,0,0,0,0]},
    {name: "Fire Bolt EX", element: "Fire", required: [0,0,3,1,0,1,0]},
    {name: "Spiral Flare", element: "Fire", required: [0,0,5,2,0,2,0]},
    {name: "Volcanic Rave", element: "Fire", required: [4,0,8,0,0,2,0]},
    {name: "Air Strike", element: "Wind", required: [0,0,0,1,0,0,0]},
    {name: "Aerial", element: "Wind", required: [0,0,0,4,0,0,0]},
    {name: "Aero Storm", element: "Wind", required: [0,0,0,8,0,0,0]},
    {name: "Lightning", element: "Wind", required: [0,0,0,4,0,2,0]},
    {name: "Plasma Wave", element: "Wind", required: [0,0,0,8,0,4,0]},
    {name: "Soul Blur", element: "Time", required: [0,0,0,0,1,0,0]},
    {name: "Shadow Spear", element: "Time", required: [0,0,0,0,5,0,0]},
    {name: "Hell Gate", element: "Time", required: [0,0,0,0,4,2,1]},
    {name: "White Gehenna", element: "Time", required: [0,0,0,0,8,4,2]},
    {name: "Clock Up", element: "Time", required: [0,0,0,0,1,0,0]},
    {name: "Clock Up EX", element: "Time", required: [0,0,0,0,9,0,0]},
    {name: "Anti-Sept", element: "Time", required: [0,0,0,0,3,0,0]},
    {name: "Anti-Sept All", element: "Time", required: [0,0,0,0,11,0,0]},
    {name: "Chaos Brand", element: "Mirage", required: [0,0,0,0,0,0,5]},
    {name: "Earth Guard", element: "Earth", required: [2,0,0,0,0,0,0]},
    {name: "Earth Wall", element: "Earth", required: [4,0,0,0,0,0,0]},
    {name: "Sylphen Guard", element: "Wind", required: [0,0,0,2,0,0,0]},
    {name: "Sylphen Wing", element: "Wind", required: [0,0,0,6,0,0,0]},
    {name: "Crest", element: "Earth", required: [4,3,0,0,0,2,1]},
    {name: "Forte", element: "Fire", required: [0,0,4,3,0,2,1]},
    {name: "Saint", element: "Mirage", required: [3,2,3,2,0,2,4]},
    {name: "Tear", element: "Water", required: [0,1,0,0,0,0,0]},
    {name: "Teara", element: "Water", required: [0,4,0,0,0,0,0]},
    {name: "Tearal", element: "Water", required: [0,6,0,0,0,0,0]},
    {name: "La Tear", element: "Water", required: [0,2,0,0,0,1,0]},
    {name: "La Teara", element: "Water", required: [0,5,0,0,0,2,0]},
    {name: "Curia", element: "Water", required: [0,4,0,0,0,0,2]},
    {name: "La Curia", element: "Water", required: [0,8,0,0,0,2,4]},
    {name: "Revive", element: "Water", required: [2,4,0,0,0,0,1]}
]

$all_quartz = [
    {name: "HP 1", type: "HP", element: "Water", value: [0,1,0,0,0,0,0], cost: [0,20,0,0,0,0,0]},
    {name: "HP 2", type: "HP", element: "Water", value: [0,3,0,0,0,0,0], cost: [0,200,0,0,0,0,0]},
    {name: "HP 3", type: "HP", element: "Water", value: [0,5,0,0,0,0,0], cost: [0,800,0,0,0,0,0]},
    {name: "EP 1", type: "EP", element: "Mirage", value: [0,0,0,0,1,1,2], cost: [0,0,0,0,10,10,30]},
    {name: "EP 2", type: "EP", element: "Mirage", value: [0,0,0,0,2,2,3], cost: [0,0,0,0,100,100,200]},
    {name: "EP 3", type: "EP", element: "Mirage", value: [0,0,0,0,3,3,5], cost: [0,0,0,0,500,500,800]},
    {name: "Attack 1", type: "Attack", element: "Fire", value: [0,0,1,0,0,0,0], cost: [0,0,20,0,0,0,0]},
    {name: "Attack 2", type: "Attack", element: "Fire", value: [0,0,3,0,0,0,0], cost: [0,0,200,0,0,0,0]},
    {name: "Attack 3", type: "Attack", element: "Fire", value: [0,0,5,0,0,0,0], cost: [0,0,800,0,0,0,0]},
    {name: "Defense 1", type: "Defense", element: "Earth", value: [1,0,0,0,0,0,0], cost: [20,0,0,0,0,0,0]},
    {name: "Defense 2", type: "Defense", element: "Earth", value: [3,0,0,0,0,0,0], cost: [200,0,0,0,0,0,0]},
    {name: "Defense 3", type: "Defense", element: "Earth", value: [5,0,0,0,0,0,0], cost: [800,0,0,0,0,0,0]},
    {name: "Mind 1", type: "Mind", element: "Water", value: [0,1,0,0,0,0,0], cost: [0,30,0,0,0,0,0]},
    {name: "Mind 2", type: "Mind", element: "Water", value: [0,3,0,0,0,0,0], cost: [0,300,0,0,0,0,0]},
    {name: "Mind 3", type: "Mind", element: "Water", value: [0,5,0,0,0,0,0], cost: [0,900,0,0,0,0,0]},
    {name: "Range", type: "Range", element: "Space", value: [0,0,0,0,0,3,0], cost: [0,0,0,0,0,0,0]},
    {name: "Shield 1", type: "Shield", element: "Wind", value: [0,0,0,1,0,0,0], cost: [0,0,0,20,0,0,0]},
    {name: "Shield 2", type: "Shield", element: "Wind", value: [0,0,0,3,0,0,0], cost: [0,0,0,200,0,0,0]},
    {name: "Shield 3", type: "Shield", element: "Wind", value: [0,0,0,5,0,0,0], cost: [0,0,0,800,0,0,0]},
    {name: "Hit 1", type: "Hit", element: "Mirage", value: [0,0,0,0,0,0,1], cost: [0,0,0,0,0,0,20]},
    {name: "Hit 2", type: "Hit", element: "Mirage", value: [0,0,0,0,0,0,3], cost: [0,0,0,0,0,0,200]},
    {name: "Hit 3", type: "Hit", element: "Mirage", value: [0,0,0,0,0,0,5], cost: [0,0,0,0,0,0,800]},
    {name: "Evade 1", type: "Evade", element: "Wind", value: [0,0,0,1,0,0,0], cost: [0,0,0,20,0,0,0]},
    {name: "Evade 2", type: "Evade", element: "Wind", value: [0,0,0,3,0,0,0], cost: [0,0,0,200,0,0,0]},
    {name: "Evade 3", type: "Evade", element: "Wind", value: [0,0,0,5,0,0,0], cost: [0,0,0,800,0,0,0]},
    {name: "Move 1", type: "Move", element: "Space", value: [0,0,0,0,0,1,0], cost: [0,0,0,0,0,100,0]},
    {name: "Move 2", type: "Move", element: "Space", value: [0,0,0,0,0,3,0], cost: [0,0,0,0,0,200,0]},
    {name: "Move 3", type: "Move", element: "Space", value: [0,0,0,0,0,5,0], cost: [0,0,0,0,0,1000,0]},
    {name: "Action 1", type: "Action", element: "Time", value: [0,0,0,0,1,0,0], cost: [0,0,0,0,20,0,0]},
    {name: "Action 2", type: "Action", element: "Time", value: [0,0,0,0,3,0,0], cost: [0,0,0,0,200,0,0]},
    {name: "Action 3", type: "Action", element: "Time", value: [0,0,0,0,5,0,0], cost: [0,0,0,0,800,0,0]},
    {name: "Cast 1", type: "Cast", element: "Time", value: [0,0,0,0,1,0,0], cost: [0,0,0,0,20,0,0]},
    {name: "Cast 2", type: "Cast", element: "Time", value: [0,0,0,0,3,0,0], cost: [0,0,0,0,200,0,0]},
    {name: "Poison", type: "Chance", element: "Earth", value: [3,0,0,0,0,0,0], cost: [50,0,0,0,0,0,0]},
    {name: "Freeze", type: "Chance", element: "Water", value: [0,3,0,0,0,0,0], cost: [0,50,0,0,0,0,0]},
    {name: "Petrify", type: "Chance", element: "Earth", value: [3,0,0,0,0,0,0], cost: [0,0,0,0,0,0,0]},
    {name: "Sleep", type: "Chance", element: "Wind", value: [0,0,0,3,0,0,0], cost: [0,0,0,50,0,0,0]},
    {name: "Mute", type: "Chance", element: "Earth", value: [3,0,0,0,0,0,0], cost: [50,0,0,0,0,0,0]},
    {name: "Blind", type: "Chance", element: "Time", value: [0,0,0,0,3,0,0], cost: [0,0,0,0,50,0,0]},
    {name: "Seal", type: "Chance", element: "Fire", value: [0,0,3,0,0,0,0], cost: [0,0,50,0,0,0,0]},
    {name: "Confuse", type: "Chance", element: "Fire", value: [0,0,3,0,0,0,0], cost: [0,0,50,0,0,0,0]},
    {name: "Strike", type: "Chance", element: "Fire", value: [0,0,3,0,0,0,0], cost: [0,0,0,0,0,0,0]},
    {name: "Deathblow 1", type: "Chance", element: "Time", value: [0,0,0,0,3,0,0], cost: [0,0,0,0,0,0,0]},
    {name: "Deathblow 2", type: "Chance", element: "Time", value: [0,0,0,0,0,0,0], cost: [0,0,0,0,0,0,0]},
    {name: "EP Cut 1", type: "EP Cut", element: "Space", value: [0,0,0,0,1,2,1], cost: [0,0,0,0,10,20,10]},
    {name: "EP Cut 2", type: "EP Cut", element: "Space", value: [0,0,0,0,2,3,2], cost: [0,0,0,0,100,200,100]},
    {name: "EP Cut 3", type: "EP Cut", element: "Space", value: [0,0,0,0,3,5,3], cost: [0,0,0,0,800,1000,800]},
    {name: "Impede 1", type: "Impede", element: "Wind", value: [0,0,0,1,0,0,0], cost: [0,0,0,30,0,0,0]},
    {name: "Impede 2", type: "Impede", element: "Wind", value: [0,0,0,3,0,0,0], cost: [0,0,0,300,0,0,0]},
    {name: "Impede 3", type: "Impede", element: "Wind", value: [0,0,0,5,0,0,0], cost: [0,0,0,900,0,0,0]},
    {name: "Information", type: "Information", element: "Mirage", value: [0,0,0,0,0,0,2], cost: [0,0,0,0,0,0,0]},
    {name: "Scent", type: "Scent", element: "Wind", value: [0,0,0,3,0,2,0], cost: [0,0,0,0,0,0,0]},
    {name: "Eagle Eye", type: "Eagle Eye", element: "Space", value: [0,0,0,0,0,3,2], cost: [0,0,0,0,0,0,0]},
    {name: "Haze", type: "Haze", element: "Mirage", value: [2,0,0,0,0,0,3], cost: [0,0,0,0,0,0,0]},
    {name: "Cloak", type: "Cloak", element: "Mirage", value: [0,0,2,0,0,0,3], cost: [0,0,0,0,0,0,0]},
    {name: "Heal", type: "Heal", element: "Water", value: [0,3,0,0,2,0,0], cost: [0,0,0,0,0,0,0]}
]

$element_string = ["Earth", "Water", "Fire", "Wind", "Time", "Space", "Mirage"]

def name_quartz_from_index(quartz_list, bold_list = [])
    out = ""
    for quartz_index in quartz_list
        bold = bold_list.include? quartz_index
        if bold
            out += "*"
        end
        out += $all_quartz[quartz_index][:name]
        if bold
            out += "*"
        end
        out += ", "
    end
    if out.length < 3
        return ""
    end
    return out[0..-3]
end

def name_magic_from_index(magic_list, bold_list = [])
    out = ""
    for magic_index in magic_list
        bold = bold_list.include? magic_index
        if bold
            out += "*"
        end
        out += $all_magic[magic_index][:name]
        if bold
            out += "*"
        end
        out += ", "
    end
    if out.length < 3
        return ""
    end
    return out[0..-3]
end

def name_elements_from_index(element_list)
    out = ""
    for i in 0...element_list.length
        if element_list[i] > 0
            out += element_list[i].to_s + " " + $element_string[i] + ", "
        end
    end
    if out.length < 3
        return ""
    end
    return out[0..-3]
end

def array_add(a, b)
    (0...a.length).each do |i|
        a[i] += b[i]
    end
    return a
end

def array_a_not_greater_than_b(a, b)
    (0...a.length).each do |i|
        if (a[i] > b[i])
            return false
        end
    end
    return true
end

def data_line_parse(data_line)
    out = Array.new
    cur = Array.new
    for element in data_line
        if element.nil?
            out.push([])
        elsif element < 0
            out.push(cur)
            cur = Array.new
        else
            cur.push(element)
        end
    end
    if (cur.length)
        out.push(cur)
    end
    return out
end

def subset?(a, b)
    if a.length < b.length
        return false
    else
        for i in 0...b.length
            unless a.include?(b[i])
                return false
            end
        end
    end
    return true
end

def search(job_list)
    message = "Searching for the following: \n"
    for i in 0...job_list.length

        current_msg = ""
        if job_list[i][3] == :magic
            current_msg += name_magic_from_index(job_list[i][0])
        elsif job_list[i][3] == :quartz
            current_msg += name_quartz_from_index(job_list[i][0])
        end
        current_msg += " (Quartz Limit: " + job_list[i][1].to_s + ")"
        message += current_msg + "\n"
        if job_list[i][2] == :verbose
            $out[i].syswrite(current_msg + "\n\n")
        end
    end
    puts message
    line = 0
    found = 0
    milestone = 0
    max_quartz = 0
    for job in job_list
        if job[3] == :quartz
            job[1] = [job[1], job[0].length].min
        end
        max_quartz = [max_quartz, job[1]].max
    end
    finish = 0
    if max_quartz == 1
        finish = 56
    elsif max_quartz == 2
        finish = 1504
    elsif max_quartz == 3
        finish = 24610
    elsif max_quartz == 4
        finish = 280685
    elsif max_quartz == 5
        finish = 4834308
    elsif max_quartz == 6
        finish = 18085428
    end
    CSV.foreach('data.csv', converters: :numeric) do |row|
        line += 1
        if line > finish
            break
        end
        line_info = data_line_parse(row)
        quartz_combination = line_info[0]
        elemental_value = line_info[1]
        magic_available = line_info[2]
        cleanup = false
        for i in 0...job_list.length
            match = false
            if quartz_combination.length > job_list[i][1]
                cleanup = true
                job_list[i] = :done
            else
                if job_list[i][3] == :magic
                    if subset?(magic_available, job_list[i][0])
                        match = true
                    end
                elsif job_list[i][3] == :quartz                
                    if subset?(job_list[i][0], quartz_combination)
                        match = true
                    end
                end
            end
            if match
                if job_list[i][2] == :verbose
                    msg = "Quartz Count: " + quartz_combination.length.to_s +
                          "\nQuartz Combination: " + name_quartz_from_index(quartz_combination) +
                          "\nElemental Value: " + name_elements_from_index(elemental_value) +
                          "\nMagic Usable: " + name_magic_from_index(magic_available) + "\n\n"
                    $out[i].syswrite(msg)
                elsif job_list[i][2] == :simple
                    $out[i].syswrite(line.to_s + "\n")
                end
                found += 1
            end
        end
        if cleanup
            new_job_list = []
            for job in job_list
                unless job == :done
                    new_job_list.push(job)
                end
            end
            job_list = new_job_list
        end
        progress = line * 100 / finish
        if progress >= milestone
            puts progress.to_s + "% searched (" + line.to_s + "/" + finish.to_s + "). Found " + found.to_s + " matches."
            milestone += 1
        end        
    end
    puts "Done"
end

search_list = []
$out = []
CSV.foreach('in.txt', converters: :numeric) do |row|
    if row.length > 2
        $out.push(File.new("output/" + (row[0, 3].to_s[1..-2] + "-" + row[3..-1].sort.to_s[1..-2]).gsub(", ", "-") + ".txt", "w"))
        output = :verbose
        mode = :magic
        if row[0] == 1
            mode = :quartz
        end
        if row[1] == 1
            output = :simple
        end
        search_list.push([row[3..-1], row[2], output, mode])
    end
end
search(search_list)
for fout in $out
    fout.close
end